OGRE: Ogre::AnimationTrack Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::AnimationTrack Class Referenceabstract
Core » Animation

A 'track' in an animation sequence, i.e. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::AnimationTrack:
[legend]

## Classes
class | Listener
| Listener allowing you to override certain behaviour of a track, for example to drive animation procedurally. More...

## Public Member Functions
| AnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
virtual | ~AnimationTrack ()
virtual void | _applyBaseKeyFrame (const KeyFrame *base)
| Internal method to re-base the keyframes relative to a given keyframe.
virtual void | _buildKeyFrameIndexMap (const std::vector< Real > &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.
virtual void | _collectKeyFrameTimes (std::vector< Real > &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format.
virtual void | _keyFrameDataChanged (void) const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
virtual void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)=0
| Applies an animation track to the designated target.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
unsigned short | getHandle (void) const
| Get the handle associated with this track.
virtual void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const =0
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified.
KeyFrame * | getKeyFrame (size_t index) const
| Returns the KeyFrame at the specified index.
float | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
size_t | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
Animation * | getParent () const
| Returns the parent Animation object for this track.
virtual bool | hasNonZeroKeyFrames (void) const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
virtual void | optimise (void)
| Optimise the current track by removing any duplicate keyframes.
void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | setListener (Listener *l)
| Set a listener for this track.

## Detailed Description

A 'track' in an animation sequence, i.e.

a sequence of keyframes which affect a certain type of animable object.

This class is intended as a base for more complete classes which will actually animate specific types of object, e.g. a bone in a skeleton to affect skeletal animation. An animation will likely include multiple tracks each of which can be made up of many KeyFrame instances. Note that the use of tracks allows each animable object to have it's own number of keyframes, i.e. you do not have to have the maximum number of keyframes for all animable objects just to cope with the most animated one.

Since the most common animable object is a Node, there are options in this class for associating the track with a Node which will receive keyframe updates automatically when the 'apply' method is called.

By default rotation is done using shortest-path algorithm. It is possible to change this behaviour using setUseShortestRotationPath() method.

## Constructor & Destructor Documentation

## ◆ AnimationTrack()

Ogre::AnimationTrack::AnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle )

Constructor.

Referenced by Ogre::AnimationTrack::Listener::getInterpolatedKeyFrame().

## ◆ ~AnimationTrack()

virtual Ogre::AnimationTrack::~AnimationTrack | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getHandle()

unsigned short Ogre::AnimationTrack::getHandle | ( | void |  | ) | const
| inline

Get the handle associated with this track.

## ◆ getNumKeyFrames()

size_t Ogre::AnimationTrack::getNumKeyFrames | ( | void |  | ) | const
| inline

Returns the number of keyframes in this animation.

## ◆ getKeyFrame()

KeyFrame * Ogre::AnimationTrack::getKeyFrame | ( | size_t | index | ) | const
| inline

Returns the KeyFrame at the specified index.

## ◆ getKeyFramesAtTime()

float Ogre::AnimationTrack::getKeyFramesAtTime | ( | const TimeIndex & | timeIndex,
|  | KeyFrame ** | keyFrame1,
|  | KeyFrame ** | keyFrame2,
|  | unsigned short * | firstKeyIndex = 0 ) const

Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.

At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after.

  This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc.

Parameters

  timeIndex | The time index.
  keyFrame1 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just before or at this time index.
  keyFrame2 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just after this time index.
  firstKeyIndex | Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe in case the caller needs it.

Returns
  Parametric value indicating how far along the gap between the 2 keyframes the timeIndex value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 <= returnValue < 1.0 .

## ◆ createKeyFrame()

virtual KeyFrame * Ogre::AnimationTrack::createKeyFrame | ( | Real | timePos | ) |
| virtual

Creates a new KeyFrame and adds it to this animation at the given time index.

It is better to create KeyFrames in time order.

Parameters

  timePos | The time from which this KeyFrame will apply.

## ◆ removeKeyFrame()

virtual void Ogre::AnimationTrack::removeKeyFrame | ( | unsigned short | index | ) |
| virtual

Removes a KeyFrame by it's index.

## ◆ removeAllKeyFrames()

void Ogre::AnimationTrack::removeAllKeyFrames | ( | void |  | ) |

Removes all the KeyFrames from this track.

## ◆ getInterpolatedKeyFrame()

virtual void Ogre::AnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf ) const
| pure virtual

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters

  timeIndex | The time (in relation to the whole animation sequence)
  kf | Keyframe object to store results

Implemented in Ogre::NodeAnimationTrack, Ogre::NumericAnimationTrack, and Ogre::VertexAnimationTrack.

## ◆ apply()

virtual void Ogre::AnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )
| pure virtual

Applies an animation track to the designated target.

Parameters

  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implemented in Ogre::NodeAnimationTrack, Ogre::NumericAnimationTrack, and Ogre::VertexAnimationTrack.

## ◆ _keyFrameDataChanged()

virtual void Ogre::AnimationTrack::_keyFrameDataChanged | ( | void |  | ) | const
| inlinevirtual

Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.

Reimplemented in Ogre::NodeAnimationTrack.

## ◆ hasNonZeroKeyFrames()

virtual bool Ogre::AnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const
| inlinevirtual

Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.

Reimplemented in Ogre::NodeAnimationTrack, and Ogre::VertexAnimationTrack.

## ◆ optimise()

virtual void Ogre::AnimationTrack::optimise | ( | void |  | ) |
| inlinevirtual

Optimise the current track by removing any duplicate keyframes.

Reimplemented in Ogre::NodeAnimationTrack, and Ogre::VertexAnimationTrack.

## ◆ _collectKeyFrameTimes()

virtual void Ogre::AnimationTrack::_collectKeyFrameTimes | ( | std::vector< Real > & | keyFrameTimes | ) |
| virtual

Internal method to collect keyframe times, in unique, ordered format.

## ◆ _buildKeyFrameIndexMap()

virtual void Ogre::AnimationTrack::_buildKeyFrameIndexMap | ( | const std::vector< Real > & | keyFrameTimes | ) |
| virtual

Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.

## ◆ _applyBaseKeyFrame()

virtual void Ogre::AnimationTrack::_applyBaseKeyFrame | ( | const KeyFrame * | base | ) |
| virtual

Internal method to re-base the keyframes relative to a given keyframe.

Reimplemented in Ogre::NodeAnimationTrack, and Ogre::VertexAnimationTrack.

## ◆ setListener()

virtual void Ogre::AnimationTrack::setListener | ( | Listener * | l | ) |
| inlinevirtual

Set a listener for this track.

## ◆ getParent()

Animation * Ogre::AnimationTrack::getParent | ( |  | ) | const
| inline

Returns the parent Animation object for this track.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h